// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPComponent.h"

@protocol Component1InputProtocol
- (void)ping;
@end

@protocol Component1OutputProtocol
- (void)pong;
@end

@interface Component1 : SHPComponent <Component1InputProtocol>

@property (nonatomic) SHPInputPort<Component1InputProtocol> *inputPort;
@property (nonatomic) SHPOutputPort<Component1OutputProtocol> *outputPort;

- (id)initWithGoal:(NSUInteger)goal;

- (void)start;
@end