// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "Component1.h"

@implementation Component1 {
    NSInteger _startingGoal;
    NSInteger _goal;
    CFTimeInterval _startTime;
}

- (id)initWithGoal:(NSUInteger)goal {
    self = [super init];
    if (self) {
        self.inputPort = [self inputPortWithProtocol:@protocol(Component1InputProtocol) name:@"Input"];
        self.outputPort = [self outputPortWithProtocol:@protocol(Component1OutputProtocol) name:@"Output"];
        _startingGoal = goal;
        _goal = _startingGoal;
    }

    return self;
}


- (void)ping {
    _goal--;
    if(_goal!=0) {
        [self.outputPort pong];
    } else {
        CFTimeInterval timeInterval = CACurrentMediaTime() - _startTime;
        NSLog(@"%f sec / %i msg", timeInterval, _startingGoal);
        NSLog(@"%.1f msg / sec", _startingGoal / timeInterval);
    }
}


- (void)start {
    _startTime = CACurrentMediaTime();
    [self ping];
}

@end