// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "Object1.h"
#import "Object2.h"

@implementation Object1 {
    NSInteger _startingGoal;
    NSInteger _goal;

    CFTimeInterval _startTime;
}

- (id)initWithGoal:(NSInteger)goal {
    self = [super init];
    if (self) {
        _startingGoal = goal;
        _goal = _startingGoal;
    }

    return self;
}

- (void)ping {
    _goal--;
    if(_goal!=0) {
        dispatch_async(dispatch_get_main_queue(), ^{
            [_object2 pong];
        });
    } else {
        CFTimeInterval timeInterval = CACurrentMediaTime() - _startTime;
        NSLog(@"%f sec / %i msg", timeInterval, _startingGoal);
        NSLog(@"%.1f msg / sec", _startingGoal / timeInterval);
    }
}

- (void)start {
    _startTime = CACurrentMediaTime();
    [self ping];
}

@end