// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "React1.h"
#import "RACSignal.h"
#import "React2.h"
#import "RACSubscriptingAssignmentTrampoline.h"
#import "NSObject+RACPropertySubscribing.h"
#import "RACSignal+Operations.h"

@interface React1 ()
@property(nonatomic) NSInteger goal;
@end

@implementation React1 {
    NSUInteger _startingGoal;
    CFTimeInterval _startTime;
}

- (id)initWithGoal:(NSUInteger)goal {
    self = [super init];
    if (self) {
        _startingGoal = goal;
        self.goal = _startingGoal;

    }

    return self;
}

- (void)start {
    _startTime = CACurrentMediaTime();
    RACSignal *pongSignal = RACObserve(self.react2, pong);

    [pongSignal subscribeNext:^(id x) {
        dispatch_async(dispatch_get_main_queue(), ^{
            self.goal--;

            if(self.goal!=0) {
                self.ping = YES;
            } else {
                CFTimeInterval timeInterval = CACurrentMediaTime() - _startTime;
                NSLog(@"%f sec / %i msg", timeInterval, _startingGoal);
                NSLog(@"%.1f msg / sec", _startingGoal / timeInterval);
            }
        });
    }];

}


@end