// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

/**
 Utilities class with miscelaneous utility c functions

 See the documentation for each method for more information
 */


#import <Foundation/Foundation.h>

/// ---------------------------------------------------------------------
/// @name UDIDs
/// ---------------------------------------------------------------------

/**
 Creates a random UDID and returns it as an NSString
*/
NSString *SHPCreateUDID();

/// ---------------------------------------------------------------------
/// @name Dispatch queues
/// ---------------------------------------------------------------------

/**
 Creates a serial dispatch queue with a random name
*/
dispatch_queue_t SHPCreateSerialQueueWithRandomName();

/**
 Creates a dispatch timer with the given properties

 The documentation for this method should be expanded
*/
dispatch_source_t SHPCreateDispatchTimer(uint64_t interval, uint64_t leeway, dispatch_queue_t queue, dispatch_block_t block);



#define SHPLog(format,...) SHPLogFunction(format, [@""__FILE__ lastPathComponent], __LINE__, ##__VA_ARGS__);
void SHPLogFunction(NSString *format, NSString *file, NSUInteger line, ...);
