// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPStateChart.h"
#import "SHPComponent.h"
#import "SHPOutputPort.h"

@class SHPSocketConnectionInfo;
@class SHPInputPort;

@protocol SHPBonjourBrowserCommandProtocol
@optional
- (void)eventBonjourBrowserSearch;
- (void)eventBonjourBrowserStop;
@end

@protocol SHPBonjourBrowserNotificationProtocol
@optional
- (void)eventBonjourBrowserSearching;
- (void)eventBonjourBrowserStopping;
- (void)eventBonjourBrowserStopped;
- (void)eventBonjourBrowserFoundServiceWithConnectionInfo:(SHPSocketConnectionInfo *)connectionInfo;
- (void)eventBonjourBrowserLostServiceWithConnectionInfo:(SHPSocketConnectionInfo *)connectionInfo;
- (void)eventBonjourBrowserFoundDomain:(NSString *)domain;
- (void)eventBonjourBrowserLostDomain:(NSString *)domain;

@end


@interface SHPBonjourBrowserStateChart : SHPStateChart <NSNetServiceDelegate>

@property (nonatomic, readonly) SHPInputPort<SHPBonjourBrowserCommandProtocol> *commandInputPort;
@property (nonatomic, readonly) SHPOutputPort<SHPBonjourBrowserNotificationProtocol> *dataOutputPort;

@property(nonatomic, readonly) NSNetServiceBrowser *browser;
@property(nonatomic, readonly) NSString *domain;
@property(nonatomic, readonly) NSString *type;
@property(nonatomic, readonly) NSMutableArray *services;

- (instancetype)initWithDomain:(NSString *)domain type:(NSString *)type;


@end