// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPPort.h"
#import "SHPChannel.h"

@class SHPInputPort;
@class SHPEventMessage;

@protocol SHPInputPortProtocol <NSObject>
- (void)inputPort:(SHPInputPort *)inputPort didReceiveMessage:(SHPEventMessage *)message;
@property (nonatomic, readonly) dispatch_queue_t messageQueue;
@property (nonatomic, readonly) NSMutableDictionary *portTraceDictionary;
@end

@interface SHPInputPort : SHPPort <SHPChannelDelegate>

@property (nonatomic, readonly, weak) id<SHPInputPortProtocol> owner;

@end