// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPStateChart.h"
#import "SHPBonjourBrowserStateChart.h"
#import "SHPSocketClientStateChart.h"

@class SHPWrappedMessage;
@class SHPSocketConnectionInfo;


@protocol SHPMessageClientBridgeInputCommandProtocol
@optional
- (void)eventMessageClientBridgeStart;
- (void)eventMessageClientBridgeStop;
@end

@protocol SHPMessageClientBridgeOutputCommandProtocol <SHPBonjourBrowserCommandProtocol, SHPSocketClientCommandProtocol>
@optional
@end

@protocol SHPMessageClientBridgeInputNotificationProtocol <SHPBonjourBrowserNotificationProtocol, SHPSocketClientNotificationProtocol>
@end

@protocol SHPMessageClientBridgeOutputNotificationProtocol
@optional
@end

@protocol SHPMessageClientBridgeMessageOutputProtocol
@optional
- (void)eventMessageClientBridgeReceivedMessage:(SHPWrappedMessage *)message;
@end

@protocol SHPMessageClientBridgeMessageInputProtocol
@optional
- (void)eventMessageClientBridgeSendMessage:(SHPWrappedMessage *)message;
@end

@interface SHPMessageClientBridgeStateChart : SHPStateChart

@property(nonatomic, readonly) SHPOutputPort<SHPMessageClientBridgeOutputCommandProtocol> *commandOutputPort;
@property(nonatomic, readonly) SHPInputPort<SHPMessageClientBridgeInputCommandProtocol> *commandInputPort;
@property(nonatomic, readonly) SHPOutputPort<SHPMessageClientBridgeOutputNotificationProtocol> *notificationOutputPort;
@property(nonatomic, readonly) SHPInputPort<SHPMessageClientBridgeInputNotificationProtocol> *notificationInputPort;
@property(nonatomic, readonly) SHPOutputPort<SHPMessageClientBridgeMessageOutputProtocol> *messageOutputPort;
@property(nonatomic, readonly) SHPInputPort<SHPMessageClientBridgeMessageInputProtocol> *messageInputPort;

@end