// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPChannel.h"
#import "SHPInvocationProxy.h"

@class SHPChannel;
@class SHPComponent;

typedef enum _SHPPortType {
    SHPPortTypeInput,
    SHPPortTypeOutput,
    SHPPortTypeProxyInput,
    SHPPortTypeProxyOutput
}SHPPortType;


@interface SHPPort : SHPInvocationProxy {
@protected
    SHPChannel *_channel;
    SHPPortType _portType;
    NSString *_identifier;
    NSString *_name;
}

@property(nonatomic) SHPChannel *channel;
@property(nonatomic, weak, readonly) id owner;
@property (nonatomic, readonly) NSString *identifier;
@property (nonatomic, readonly) SHPPortType portType;
@property (nonatomic, readonly) NSString *name;

- (id)initWithOwner:(id)owner protocol:(Protocol *)protocol name:(NSString *)name;
@end