// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import <SHPStateChart/SHPState.h>

@class SHPOrState;
@class SHPStateChartGuard;
@class SHPTransitionRepresentation;

@interface SHPStateChartTransition : NSObject

@property (nonatomic, readonly) SEL event;
@property (nonatomic, readonly) NSArray *fromStates;
@property (nonatomic, readonly) NSArray *toStates;
@property (nonatomic, readonly) SHPStateChartGuard *guard;
@property (nonatomic, readonly) NSNumber *timeout;
@property (nonatomic, readonly, getter=isInternal) BOOL internal;
@property (nonatomic, readonly) HistoryMode historyMode;

- (instancetype)initWithEvent:(SEL)event fromStates:(NSArray *)fromStates toStates:(NSArray *)toStates timeout:(NSNumber *)timeout internal:(BOOL)internal guard:(SHPStateChartGuard *)guard historyMode:(HistoryMode)historyMode;

- (SHPTransitionRepresentation *)representationForTransition;

+ (instancetype)transitionWithEvent:(SEL)event fromStates:(NSArray *)fromStates toStates:(NSArray *)toStates timeout:(NSNumber *)timeout internal:(BOOL)internal guard:(SHPStateChartGuard *)guard historyMode:(HistoryMode)historyMode;

@end
