// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "AppDelegate.h"
#import "Component.h"

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Specify number of components that should be created
    // **************************************************
    NSUInteger numberOfComponents = 513;
    // **************************************************

    [self startTestWithNumberOfComponents:numberOfComponents];
    [self setupWindow];

    return YES;
}

- (void)startTestWithNumberOfComponents:(NSUInteger)numberOfComponents {
    __block int done = 0;
    NSMutableArray *intervals = [NSMutableArray new];

    for (int i = 0; i < numberOfComponents; i++) {
        Component *component = [[Component alloc] initWithCompletion:^(NSTimeInterval interval){
            [intervals addObject:@(interval)];
            done++;
            if(done == numberOfComponents) {
                float max = [[intervals valueForKeyPath:@"@max.floatValue"] floatValue];
                float min = [[intervals valueForKeyPath:@"@min.floatValue"] floatValue];
                NSLog(@"max = %f", max);
                NSLog(@"min = %f", min);

            }
        }];
    }
}

- (void)setupWindow {
    self.window = [[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]];
    // Override point for customization after application launch.
    self.window.backgroundColor = [UIColor whiteColor];
    [self.window makeKeyAndVisible];
}

@end