// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "Component.h"


@implementation Component {

}

- (id)initWithCompletion:(void (^)(NSTimeInterval))completion {
    self = [super init];
    if (self) {
        self.dispatchQueue = dispatch_queue_create([@"Queue" cStringUsingEncoding:NSASCIIStringEncoding], DISPATCH_QUEUE_SERIAL);

        NSTimeInterval interval = CACurrentMediaTime();

        dispatch_async(self.dispatchQueue, ^{
            sleep(2);
            dispatch_async(dispatch_get_main_queue(), ^{
                completion(CACurrentMediaTime()-interval);
            });
        });
    }

    return self;
}

@end