// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPComponent.h"
#import "SHPStateChart.h"

@protocol ExpenseModelInputProtocol;
@protocol ExpenseModelOutputProtocol;

@protocol DebtsModelEventProtocol
- (void)didFetchDebts:(NSArray *)debts;
@end

@protocol DebtsInputProtocol
- (void)fetchDebts;
@end

@protocol DebtsOutputProtocol
- (void)didFetchDebts:(NSArray *)debts;
@end

@interface DebtsModel : SHPStateChart

@property(nonatomic, readonly) SHPInputPort<DebtsInputProtocol> *inputPort;
@property(nonatomic, readonly) SHPOutputPort<DebtsOutputProtocol> *outputPort;
@property(nonatomic, readonly) SHPEventPort<DebtsModelEventProtocol> *eventPort;
@property(nonatomic, readonly) SHPOutputPort<ExpenseModelOutputProtocol> *expenseInputPort;
@property(nonatomic, readonly) SHPInputPort<ExpenseModelInputProtocol> *expenseOutputPort;

@end