// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>

@class User;
@class ExpenseCategory;


@interface Expense : NSObject

@property(nonatomic, readonly) NSNumber *amount;
@property(nonatomic, readonly) User *payer;
@property(nonatomic, readonly) ExpenseCategory *category;
@property (nonatomic, readonly) NSString *identifier;

- (instancetype)initWithAmount:(NSNumber *)amount payer:(User *)payer category:(ExpenseCategory *)category;
+ (instancetype)expenseWithAmount:(NSNumber *)amount payer:(User *)payer;

@end