// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "Expense.h"
#import "User.h"
#import "ExpenseCategory.h"


@implementation Expense {

}

- (instancetype)initWithAmount:(NSNumber *)amount payer:(User *)payer category:(ExpenseCategory *)category {
    self = [super init];
    if (self) {
        _category = category;
        _amount = amount;
        _payer = payer;
        _identifier = [[NSUUID UUID] UUIDString];
    }

    return self;
}

+ (instancetype)expenseWithAmount:(NSNumber *)amount payer:(User *)payer {
    return [[self alloc] initWithAmount:amount payer:payer category:nil];
}


@end