// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPStateChart.h"
#import "WebserviceDummyComponent.h"

@class Expense;


@protocol ExpenseModelInputProtocol
- (void)fetchExpenses;
- (void)deleteExpense:(Expense *)expense;
- (void)createExpenseWithAmount:(NSNumber *)amount category:(NSString*)category;
@end

@protocol ExpenseModelOutputProtocol
- (void)fetchedExpenses:(NSArray *)expenses;
@end

@protocol ExpenseModelEventProtocol <ExpenseModelOutputProtocol, ExpenseModelInputProtocol>
@end

@interface ExpenseModel : SHPStateChart

@property (nonatomic, readonly) SHPInputPort<ExpenseModelInputProtocol> *inputPort;
@property (nonatomic, readonly) SHPOutputPort<ExpenseModelOutputProtocol> *outputPort;
@property (nonatomic, readonly) SHPEventPort<ExpenseModelEventProtocol> *eventPort;

@property (nonatomic, readonly) SHPInputPort<WebserviceOutputProtocol> *webserviceInputPort;
@property (nonatomic, readonly) SHPOutputPort<WebserviceInputProtocol> *webserviceOutputPort;

@end