// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPComponent.h"
#import "ExpenseModel.h"
#import "DebtsModel.h"

@class SHPProxyInputPort;
@class SHPProxyOutputPort;

@protocol ModelComponentInputProtocol <ExpenseModelInputProtocol, DebtsInputProtocol>
@end

@protocol ModelComponentOutputProtocol <ExpenseModelOutputProtocol, DebtsOutputProtocol>
@end

@interface ModelComponent : SHPComponent

@property(nonatomic, readonly) SHPProxyInputPort<ModelComponentInputProtocol> *inputPort;
@property(nonatomic, readonly) SHPProxyOutputPort<ModelComponentOutputProtocol> *outputPort;

@end