// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "ModelComponent.h"
#import "SHPProxyInputPort.h"
#import "SHPMessageRouter.h"
#import "SHPProxyOutputPort.h"
#import "DebtsModel.h"


@implementation ModelComponent {
    ExpenseModel * _expenseModel;
    DebtsModel *_debtsModel;
    WebserviceDummyComponent *_webserviceComponent;
}

- (id)init {
    self = [super init];
    if (self) {
        _inputPort = [self proxyInputPortWithProtocol:@protocol(ModelComponentInputProtocol) name:@"Input"];
        _outputPort = [self proxyOutputPortWithProtocol:@protocol(ModelComponentOutputProtocol) name:@"Output"];

        _expenseModel = [ExpenseModel new];
        [_expenseModel initialTransition];
        _debtsModel = [DebtsModel new];
        [_debtsModel initialTransition];
        _webserviceComponent = [WebserviceDummyComponent new];

       _inputPort.proxyChannel = _expenseModel.inputPort.channel = _debtsModel.inputPort.channel = [[SHPMessageRouter sharedInstance] publishSubscribeChannel];
       _outputPort.proxyChannel = _expenseModel.outputPort.channel = _debtsModel.outputPort.channel = [[SHPMessageRouter sharedInstance] publishSubscribeChannel];

        _debtsModel.expenseOutputPort.channel = _expenseModel.inputPort.channel;
        _debtsModel.expenseInputPort.channel = _expenseModel.outputPort.channel;

        _expenseModel.webserviceOutputPort.channel = _webserviceComponent.inputPort.channel = [[SHPMessageRouter sharedInstance] publishSubscribeChannel];
        _expenseModel.webserviceInputPort.channel = _webserviceComponent.outputPort.channel = [[SHPMessageRouter sharedInstance] publishSubscribeChannel];
    }

    return self;
}


@end