// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPComponent.h"

@protocol WebserviceInputProtocol
- (void)fetchExpenses;
- (void)removeExpenseForIdentifier:(NSString *)identifier;
- (void)createExpenseWithAmount:(NSNumber *)amount category:(NSString *)category;
@end

@protocol WebserviceOutputProtocol
-(void)didFetchExpenses:(NSArray *)expenses;
- (void)didRemoveExpenseWithIdentifier:(NSString *)identifier;
- (void)didCreateExpenseWithIdentifier:(NSString *)identifier;
@end

@interface WebserviceDummyComponent : SHPComponent

@property(nonatomic, readonly) SHPOutputPort<WebserviceOutputProtocol> *outputPort;
@property(nonatomic, readonly) SHPInputPort<WebserviceInputProtocol> *inputPort;

@end
