// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import <SHPStateChart/SHPUIStateChart.h>

@protocol AddExpenseStateChartEventProtocol
- (void)createPressedWithAmount:(NSInteger)amount categoryString:(NSString *)categoryString;
- (void)amountTextFieldChangedToAmount:(NSString *)amount;
- (void)categoryTextFieldChangedToCategory:(NSString *)category;
@end

@class AddExpenseLib;
@protocol ApplicationStateChartOutputProtocol;
@class SHPProxyOutputPort;

@interface AddExpenseStateChart : SHPUIStateChart
@property(nonatomic, readonly) SHPProxyOutputPort<ApplicationStateChartOutputProtocol> *outputPort;
@property(nonatomic, strong) AddExpenseLib *lib;

@property(nonatomic, strong) NSString *amount;
@property(nonatomic, strong) NSString *category;

@end