// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPStateChart.h"
#import "SHPUIStateChart.h"
#import "ExpensesNavigationControllerStateChart.h"
#import "ExpensesListStateChart.h"
#import "TabBarLib.h"
#import "ExpensesListLib.h"
#import "ExpensesNavigationBarLib.h"
#import "ExpenseModel.h"
#import "ExpenseDetailStateChart.h"
#import "ModalStateChart.h"
#import "AddExpenseStateChart.h"
#import "DebtsStateChart.h"
#import "LoginStateChart.h"

@protocol ExpenseModelOutputProtocol;
@class TabBarStateChart;
@class SHPProxyOutputPort;
@class ModalStateChart;
@class DebtsStateChart;

@protocol ApplicationStateChartEventProtocol <LoginStateChartEventProtocol, DebtsStateChartEventProtocol, AddExpenseStateChartEventProtocol,ModalStateChartEventProtocol, ExpensesNavigationControllerStateChartEventProtocol, ExpensesListStateChartEventProtocol, ExpenseDetailStateChartEventProtocol>
- (void)expensesTabSelected;
- (void)debtsTabSelected;
@end

@protocol ApplicationStateChartDataInputProtocol <ExpenseModelOutputProtocol>
@end

@protocol ApplicationStateChartOutputProtocol<ModelComponentInputProtocol>

@end

@protocol ApplicationStateChartInputProtocol
//- (void)expensesTabSelected;
//- (void)debtsTabSelected;
@end

@interface ApplicationStateChart : SHPUIStateChart

@property(nonatomic, strong) SHPEventPort<ApplicationStateChartEventProtocol> *eventPort;
@property(nonatomic, strong) SHPInputPort<ApplicationStateChartInputProtocol> *inputPort;
@property(nonatomic, strong) SHPInputPort<ApplicationStateChartDataInputProtocol> *dataInputPort;

@property(nonatomic, strong) SHPProxyOutputPort<ApplicationStateChartOutputProtocol> *outputPort;


@property(nonatomic, readonly) ExpensesNavigationControllerStateChart *expensesNavigationControllerStateChart;
@property(nonatomic, readonly) TabBarStateChart *tabBarStateChart;
@property(nonatomic, readonly) DebtsStateChart *debtsStateChart;

@end