// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import <SHPStateChart/SHPUIStateChart.h>

@class ExpenseDetailLib;
@class Expense;
@protocol ApplicationStateChartOutputProtocol;
@class SHPProxyOutputPort;

@protocol ExpenseDetailStateChartEventProtocol
- (void)deletePressedForExpense:(Expense *)expense;
@end

@interface ExpenseDetailStateChart : SHPUIStateChart
@property(nonatomic, strong) ExpenseDetailLib *lib;
@property(nonatomic, readonly) SHPProxyOutputPort<ApplicationStateChartOutputProtocol> *outputPort;

@end