// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import <SHPStateChart/SHPUIStateChart.h>
#import "ExpenseModel.h"
#import "ModelComponent.h"

@class ExpensesListLib;
@protocol ApplicationStateChartOutputProtocol;

@protocol ExpensesListStateChartEventProtocol
- (void)refreshExpenses;
@end

@interface ExpensesListStateChart : SHPUIStateChart
@property(nonatomic, strong) ExpensesListLib *lib;
@property(nonatomic, readonly) SHPProxyOutputPort<ApplicationStateChartOutputProtocol> *outputPort;

@end