// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPUIStateChart.h"

@class ExpensesNavigationBarLib;
@class ExpensesListStateChart;
@protocol ModelComponentInputProtocol;
@class SHPProxyOutputPort;
@protocol ApplicationStateChartOutputProtocol;
@class Expense;
@class ExpenseDetailStateChart;

@protocol ExpensesNavigationControllerStateChartEventProtocol
- (void)detailPressedForExpense:(Expense *)expense;
- (void)willShowRootViewController;
- (void)willShowDetailViewController;
- (void)didShowRootViewController;
- (void)didShowDetailViewController;
@end

@interface ExpensesNavigationControllerStateChart : SHPUIStateChart

@property (nonatomic, strong) ExpensesNavigationBarLib *lib;
@property(nonatomic, readonly) ExpensesListStateChart *expensesListStateChart;
@property(nonatomic, readonly) SHPProxyOutputPort<ApplicationStateChartOutputProtocol> *outputPort;
@property(nonatomic, readonly) ExpenseDetailStateChart *expenseDetailStateChart;
@end