// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPStateChart.h"
#import "SHPUIStateChart.h"

@class LoginLib;

@protocol LoginStateChartEventProtocol
- (void)login;
- (void)logout;
- (void)sessionTimeout;
- (void)emailFieldChangedTo:(NSString *)password;
- (void)passwordFieldChangedTo:(NSString *)password;
@end

@interface LoginStateChart : SHPUIStateChart

@property (nonatomic, readonly) SHPEventPort<LoginStateChartEventProtocol> *eventPort;
@property (nonatomic, strong) NSString *password;
@property (nonatomic, strong) NSString *email;
@property (nonatomic, strong) LoginLib *lib;

@end