// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import <SHPStateChart/SHPUIStateChart.h>


@protocol ModalStateChartEventProtocol
- (void)addNewExpenseSelected;
- (void)cancelAddExpensePressed;
@end

@class AddExpenseStateChart;
@class ModalLib;
@protocol ApplicationStateChartOutputProtocol;
@class SHPProxyOutputPort;
@class LoginStateChart;

@interface ModalStateChart : SHPUIStateChart
@property (nonatomic, strong) ModalLib *lib;
@property(nonatomic, readonly) SHPProxyOutputPort<ApplicationStateChartOutputProtocol> *outputPort;
@property(nonatomic, readonly) AddExpenseStateChart *addExpenseStateChart;
@property(nonatomic, readonly) LoginStateChart *loginStateChart;
@end