// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "ExpenseDetailLib.h"
#import "ExpenseDetailViewController.h"
#import "ApplicationStateChart.h"
#import "SHPEventPort.h"
#import "Expense.h"
#import "User.h"
#import "ExpenseCategory.h"


@implementation ExpenseDetailLib {
    Expense *_expense;
}

- (id)initWithExpenseDetailViewController:(ExpenseDetailViewController *)expenseDetailViewController {
    self = [super init];
    if (self) {
        _expenseDetailViewController = expenseDetailViewController;
        [_expenseDetailViewController view];

        [_expenseDetailViewController.deleteButton addTarget:self action:@selector(deletePressed) forControlEvents:UIControlEventTouchUpInside];
    }

    return self;
}

- (void)deletePressed {
    [self.eventPort deletePressedForExpense:_expense];
    [_expenseDetailViewController.navigationController popViewControllerAnimated:YES];
}


- (void)showExpense:(Expense *)expense {
    _expense = expense;
    _expenseDetailViewController.nameLabel.text = [NSString stringWithFormat:@"Name: %@", expense.payer.name];
    _expenseDetailViewController.categoryLabel.text = [NSString stringWithFormat:@"Category: %@", expense.category.name];
    _expenseDetailViewController.amountLabel.text = [NSString stringWithFormat:@"Amount: %@ kr",expense.amount];
}

@end