// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>

@class ExpensesListLib;
@protocol ApplicationStateChartEventProtocol;
@class SHPEventPort;


@interface ExpensesNavigationBarLib : NSObject <UINavigationControllerDelegate>

@property(nonatomic, readonly) UINavigationController *navigationController;
@property(nonatomic, strong) SHPEventPort<ApplicationStateChartEventProtocol> *eventPort;

@property (nonatomic, strong) NSArray *viewControllers;

- (instancetype)initWithNavigationController:(UINavigationController *)navigationController;

- (void)transitionToViewControllerAtIndex:(NSUInteger)index;

- (void)popToRoot;
@end