// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <SHPStateChart/SHPEventPort.h>
#import "LoginLib.h"
#import "ApplicationStateChart.h"
#import "LoginViewController.h"


@implementation LoginLib {

}

- (instancetype)initWithLoginViewController:(LoginViewController *)loginViewController {
    self = [super init];
    if (self) {
        self.loginViewController = loginViewController;

        [self.loginViewController.emailTextField addTarget:self
                                action:@selector(emailTextFieldDidChange:)
                      forControlEvents:UIControlEventEditingChanged];

        [self.loginViewController.passwordTextField addTarget:self
                                   action:@selector(passwordTextFieldDidChange:)
                         forControlEvents:UIControlEventEditingChanged];

        [self.loginViewController.loginButton addTarget:self action:@selector(loginPressed) forControlEvents:UIControlEventTouchUpInside];

        self.loginViewController.emailTextField.text = @"s093263@student.dtu.dk";
        self.loginViewController.passwordTextField.text = @"12345";
    }

    return self;
}

- (void)loginPressed {
    [self.eventPort login];
}

- (void)passwordTextFieldDidChange:(id)passwordTextFieldDidChange {
    [self.eventPort passwordFieldChangedTo:self.loginViewController.passwordTextField.text];
}

- (void)emailTextFieldDidChange:(id)emailTextFieldDidChange {
    [self.eventPort emailFieldChangedTo:self.loginViewController.emailTextField.text];
}

- (void)loginButtonEnabled:(BOOL)enabled {
    self.loginViewController.loginButton.enabled = enabled;
}

- (void)showLoggedIn:(BOOL)loggedIn {
    [self.loginViewController.emailTextField resignFirstResponder];
    [self.loginViewController.passwordTextField resignFirstResponder];
}


@end