// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>

@class SHPEventPort;
@protocol ApplicationStateChartEventProtocol;
@class ExpensesNavigationBarLib;


@interface TabBarLib : NSObject <UITabBarControllerDelegate>

@property(nonatomic, readonly) ExpensesNavigationBarLib *expensesNavigationBarLib;
@property(nonatomic, readonly) UITabBarController *tabBarController;
@property(nonatomic, strong) SHPEventPort<ApplicationStateChartEventProtocol> *eventPort;

- (instancetype)initWithTabBarController:(UITabBarController *)tabBarController;
- (void)tabAtIndexSelected:(NSUInteger)index;
- (void)popToRootForTabAtIndex:(NSUInteger)index;
@end