// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "AddExpenseViewController.h"

@interface AddExpenseViewController()
@property(nonatomic, strong) UIView *divider1;
@property(nonatomic, strong) UIView *divider2;
@end

@implementation AddExpenseViewController {

}

- (void)viewDidLoad {
    [super viewDidLoad];

    [self.view setBackgroundColor:[UIColor whiteColor]];

    [self.navigationItem setLeftBarButtonItem:self.cancelButton];
    [self.navigationItem setRightBarButtonItem:self.addButton];
    [self.view addSubview:self.amountTextField];
    [self.view addSubview:self.categoryTextField];
    [self.view addSubview:self.divider1];
    [self.view addSubview:self.divider2];
}

#pragma mark - Views

- (UIBarButtonItem *)cancelButton {
    if (!_cancelButton) {
        _cancelButton = [[UIBarButtonItem alloc] initWithTitle:@"Cancel" style:UIBarButtonItemStylePlain target:nil action:nil];
    }
    return _cancelButton;
}

- (UIBarButtonItem *)addButton {
    if (!_addButton) {
        _addButton = [[UIBarButtonItem alloc] initWithTitle:@"Create" style:UIBarButtonItemStylePlain target:nil action:nil];
    }
    return _addButton;
}

- (UITextField *)amountTextField {
    if (!_amountTextField) {
        _amountTextField = [[UITextField alloc] initWithFrame:CGRectMake(20, 75, 280, 30)];
        [_amountTextField setKeyboardType:UIKeyboardTypeNumberPad];
        [_amountTextField setPlaceholder:@"Amount"];
    }
    return _amountTextField;
}

- (UITextField *)categoryTextField {
    if (!_categoryTextField) {
        _categoryTextField = [[UITextField alloc] initWithFrame:CGRectMake(20, 115, 280, 30)];
        [_categoryTextField setPlaceholder:@"Category"];
    }
    return _categoryTextField;
}

- (UIView *)divider1 {
    if (!_divider1) {
        _divider1 = [[UIView alloc] initWithFrame:CGRectMake(0, 110, 320, 0.5)];
        [_divider1 setBackgroundColor:[UIColor lightGrayColor]];
    }
    return _divider1;
}

- (UIView *)divider2 {
    if (!_divider2) {
        _divider2 = [[UIView alloc] initWithFrame:CGRectMake(0, 150, 320, 0.5)];
        [_divider2 setBackgroundColor:[UIColor lightGrayColor]];
    }
    return _divider2;
}

@end