// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "ExpensesViewController.h"
#import "View+MASAdditions.h"

@implementation ExpensesViewController {
    UITableView *_tableView;
}

- (id)init {
    self = [super init];
    if (self) {
        self.tabBarItem = [[UITabBarItem alloc] initWithTitle:@"Expenses" image:[UIImage imageNamed:@"basic1-124.png"] tag:0];
        self.tabBarItem.title = @"Expenses";
        self.title = @"Expenses";
    }

    return self;
}


- (void)viewDidLoad {
    [super viewDidLoad];

    [self addSubViews];
    [self.view setNeedsUpdateConstraints];


    _refreshButton = [[UIBarButtonItem alloc] initWithTitle:@"Refresh" style:UIBarButtonItemStylePlain target:nil action:nil];
    [self.navigationItem setLeftBarButtonItem:_refreshButton];

    _addButton = [[UIBarButtonItem alloc] initWithTitle:@"Add" style:UIBarButtonItemStylePlain target:nil action:nil];
    [self.navigationItem setRightBarButtonItem:_addButton];
}

- (void)addSubViews {
    [self.view addSubview:self.tableView];
}

- (void)updateViewConstraints {
    [super updateViewConstraints];

    [self.tableView mas_updateConstraints:^(MASConstraintMaker *make) {
        make.edges.equalTo(self.view);
    }];
}

#pragma mark - Views

- (UITableView *)tableView {
    if (!_tableView) {
        _tableView = [UITableView new];
    }
    return _tableView;
}

@end