// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPComponent.h"

@class SHPEventMessage;
@class SHPChannel;

@protocol SHPMessageRouterMonitorPortProtocol
@optional
- (void)didProcessMessage:(SHPEventMessage *)message;
@end


@interface SHPMessageRouter : SHPComponent

@property (nonatomic, readonly)SHPOutputPort<SHPMessageRouterMonitorPortProtocol> *monitorPort;

- (id)initWithMonitorChannel:(SHPChannel *)monitorChannel;

+ (SHPMessageRouter *)sharedInstance;

- (SHPChannel *)pointToPointChannel;
- (SHPChannel *)publishSubscribeChannel;
- (void)sendMessage:(SHPEventMessage *)message channel:(SHPChannel *)channel;
- (void)receiverReady:(id <SHPChannelDelegate>)receiver forChannel:(SHPChannel *)channel;
- (void)setMonitorChannel:(SHPChannel *)monitorChannel;

- (void)addPublishSubscribeChannelFromOutputPort:(SHPPort *)outputPort toInputPort:(SHPPort *)inputPort;
- (void)addPointToPointChannelFromOutputPort:(SHPPort *)outputPort toInputPort:(SHPPort *)inputPort;

@end