// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPMessageServerBridgeStateChart.h"

@class SHPProxyInputPort;
@class SHPProxyOutputPort;

@protocol SHPMessageServerBridgeComponentCommandProtocol <SHPMessageServerBridgeCommandInputProtocol>
@end

@protocol SHPMessageServerBridgeComponentNotificationProtocol <SHPMessageServerBridgeNotificationOutputProtocol>
@end

@interface SHPMessageServerBridgeComponent : SHPComponent

@property (nonatomic, readonly) SHPProxyInputPort<SHPMessageServerBridgeComponentCommandProtocol> *commandInputPort;
@property (nonatomic, readonly) SHPProxyOutputPort<SHPMessageServerBridgeComponentNotificationProtocol> *notificationOutputPort;

@property (nonatomic, readonly) SHPProxyInputPort<SHPMessageServerBridgeMessageInputProtocol> *messagesInputPort;
@property (nonatomic, readonly) SHPProxyOutputPort<SHPMessageServerBridgeMessageOutputProtocol> *messagesOutputPort;

- (void)configure;
@end