// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.



#import <Foundation/Foundation.h>

@class SHPStateChartGuardRepresentation;
@class SHPEventRepresentation;

@interface SHPTransitionRepresentation : NSObject

@property(nonatomic, strong) NSString *event;
@property(nonatomic, strong) NSArray *fromStates;
@property(nonatomic, strong) NSArray *toStates;
@property(nonatomic, strong) NSNumber *timeout;
@property(nonatomic, assign) BOOL internal;
@property(nonatomic, strong) SHPStateChartGuardRepresentation *guard;
@property(nonatomic, strong) NSString *historyMode;
@property (nonatomic, strong) NSArray *eventRepresentations;

- (id)initWithEvent:(NSString *)event fromStates:(NSArray *)fromStates toStates:(NSArray *)toStates timeout:(NSNumber *)timeout internal:(BOOL)internal guard:(SHPStateChartGuardRepresentation *)guard historyMode:(NSString *)mode;
- (void)addEventRepresentation:(SHPEventRepresentation *)eventRepresentation;

@end
