// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPComponent.h"

@class SHPWrappedMessage;

@protocol SHPMessageUnwrapperInputProtocol
- (void)messageUnwrapperUnwrapMessage:(SHPWrappedMessage *)wrappedMessage;
@end


@interface SHPMessageUnwrapperComponent : SHPComponent <SHPMessageUnwrapperInputProtocol>

@property (nonatomic, readonly) Protocol *protocol;
@property (nonatomic, readonly) NSString *channelName;
@property (nonatomic, strong) SHPInputPort<SHPMessageUnwrapperInputProtocol> *inputPort;
@property (nonatomic, strong) SHPOutputPort *outputPort;

- (id)initWithProtocol:(Protocol *)protocol channelName:(NSString *)channelName;

@end