// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>

@class SHPChannel;
@class SHPEventMessage;
@class SHPMessageRouter;

typedef enum {
    SHPChannelTypePointToPoint,
    SHPChannelTypePublishSubscribe,
} SHPChannelType;

@protocol SHPChannelDelegate <NSObject>
- (void)channel:(SHPChannel *)channel processMessage:(SHPEventMessage *)message;
- (void)channel:(SHPChannel *)channel didDeliverMessage:(SHPEventMessage *)message;
- (NSString *)name;
- (dispatch_queue_t)messageQueue;
@end

@interface SHPChannel : NSObject {
    NSString *_identifier;
}

@property(nonatomic,strong) NSMutableArray *receivers;
@property(readonly, assign) SHPChannelType type;
@property(nonatomic, copy) NSString *identifier;

- (id)initWithType:(SHPChannelType)type messageRouter:(SHPMessageRouter *)messageRouter;
- (void)postMessage:(SHPEventMessage *)message;
- (void)receiverReady:(id <SHPChannelDelegate>)receiver;

@end