// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPComponent.h"
#import "SHPEventMessage.h"

@class SHPInputPort;
@class SHPOutputPort;


@protocol SHPComponentRegisterCommandProtocol
- (void)componentRegisterAddComponent:(SHPComponent *)component;
- (void)componentRegisterRemoveComponent:(SHPComponent *)component;
- (void)componentRegisterGetComponents;
@end

@protocol SHPComponentRegisterNotificationProtocol
- (void)componentRegisterComponents:(NSArray *)components;
@end

@interface SHPComponentRegisterMessage : SHPEventMessage

@property (readonly) NSString *messageType;

- (id)initWithMessageType:(NSString *)messageType body:(id)body;
@end

@interface SHPComponentRegister : SHPComponent <SHPComponentRegisterCommandProtocol>

@property (nonatomic, readonly) SHPInputPort<SHPComponentRegisterCommandProtocol> *commandInputPort;
@property (nonatomic, readonly) SHPOutputPort<SHPComponentRegisterNotificationProtocol> *notificationOutputPort;

+ (SHPComponentRegister *)sharedInstance;

@end