// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>

@interface SHPEventMessage : NSObject
@property (nonatomic, readonly) NSInvocation *invocation;
@property (nonatomic, readonly) SEL eventType;
@property (nonatomic, readonly) NSString *identifier;
@property (nonatomic, readonly) NSTimeInterval timestamp;
@property (nonatomic, readonly) SHPEventMessage *parentMessage;
@property (nonatomic, readonly) NSString *senderName;
@property (nonatomic, readonly) NSString *traceIdentifier;

- (id)initWithEventType:(SEL)eventType invocation:(NSInvocation *)invocation;
- (id)initWithEventType:(SEL)eventType invocation:(NSInvocation *)invocation senderName:(NSString *)senderName parentMessage:(SHPEventMessage *)parentMessage;

@end