// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPState.h"

@class SHPEventMessage;
@class SHPEventHandlingResult;

@interface SHPOrState : SHPState

@property (nonatomic, readonly) NSArray *subStates;
@property (nonatomic, readonly) SHPState *initialState;
@property (nonatomic) SHPState *activeState;

// Setup
- (void)setSubStates:(NSArray *)array initialState:(SHPState *)initialState;

- (void)enterDefaultConfigurationWithEventMessage:(SHPEventMessage *)eventMessage enterSelf:(BOOL)enterSelf transitionRepresentation:(SHPTransitionRepresentation *)transitionRepresentation;

// Properties
- (BOOL)isCompositeState;

- (SHPOrStateRepresentation *)representationForState;
@end
