// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <XCTest/XCTest.h>
#import "StateChartTestBase.h"
#import "InitialTransitionStateChart.h"

@interface InitialTransitionTests : StateChartTestBase
@end


@implementation InitialTransitionTests


- (void)testInitialTransition {
    InitialTransitionStateChart *stateChart = [InitialTransitionStateChart new];
    NSAssert(stateChart.rootState.activeState == nil, @"Active state must be nil before initial transition has been perfomred");
    [stateChart initialTransition];

    dispatch_sync(stateChart.messageQueue, ^{
        NSAssert(stateChart.rootState.activeState != nil, @"Active state must not be nil after initial transition has been perfomred");
    });
}

@end