// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import <SHPStateChart/SHPPort.h>

@protocol SHPOutputPortProtocol;
@protocol SHPInputPortProtocol;
@class SHPChannel;


@interface SHPTestPort : SHPPort <SHPChannelDelegate, SHPStateChartInfoProtocol>

@property (nonatomic, readonly, weak) id<SHPOutputPortProtocol, SHPInputPortProtocol> owner;
@property (nonatomic, strong) SHPChannel *inputChannel;

- (id)init;

- (NSArray *)stateRecordingsForEventBlock:(void (^)())eventBlock eventSelector:(SEL)selector;
@end