// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <XCTest/XCTest.h>
#import "StateChartTestBase.h"
#import "Scenario2StateChart.h"
#import "SHPTestPort.h"

@interface Scenario2Tests : StateChartTestBase
@property (nonatomic, readonly) SHPTestPort<Scenario2StateChartEventProtocol> *port;
@end

@implementation Scenario2Tests

- (void)setUp
{
    [super setUp];

    [self setUpWithPortProtocol:@protocol(Scenario2StateChartEventProtocol) stateChartClass:[Scenario2StateChart class]];
}

- (void)tearDown
{
    // Put teardown code here. This method is called after the invocation of each test method in the class.
    [super tearDown];
}

- (void)testEvent1 {
    NSArray *recordings = [self.port stateRecordingsForEventBlock:^{
        [self.port event1];
    } eventSelector:@selector(event1)];

    NSArray *sequence = @[EXIT(@"State1a1"), ACTION(@"State1a1"), ENTRY(@"State1a2"), EXIT(@"State1b1"), ACTION(@"State1b1"), ENTRY(@"State1b2")];

    [self validateValidationSequence:sequence forRecordings:recordings];
}

- (void)testEven1Event2 {
    [self.port stateRecordingsForEventBlock:^{
        [self.port event1];
    } eventSelector:@selector(event1)];

    NSArray *recordings = [self.port stateRecordingsForEventBlock:^{
        [self.port event2];
    } eventSelector:@selector(event2)];

    NSArray *sequence = @[EXIT(@"State1a2"), ACTION(@"State1a2"), ENTRY(@"State1a1"), EXIT(@"State1b2"), ACTION(@"State1b2"), ENTRY(@"State1b1")];

    [self validateValidationSequence:sequence forRecordings:recordings];
}

@end
