// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <XCTest/XCTest.h>
#import "StateChartTestBase.h"
#import "SHPStateChart.h"
#import "SHPTestPort.h"
#import "Scenario3StateChart.h"

@interface Scenario3Tests : StateChartTestBase
@property (nonatomic, readonly) SHPTestPort<Scenario3StateChartEventProtocol> *port;
@end

@implementation Scenario3Tests

- (void)setUp
{
    [super setUp];

    [self setUpWithPortProtocol:@protocol(Scenario3StateChartEventProtocol) stateChartClass:[Scenario3StateChart class]];
}

- (void)tearDown
{
    // Put teardown code here. This method is called after the invocation of each test method in the class.
    [super tearDown];
}

- (void)testEvent2 {
    NSArray *recordings = [self.port stateRecordingsForEventBlock:^{
        [self.port event2];
    } eventSelector:@selector(event2)];

    NSArray *sequence = @[EXIT(@"State1a1"), EXIT(@"State1a"), EXIT(@"State1b1"), EXIT(@"State1b"), EXIT(@"State1"), ACTION(@"State1a1"), ACTION(@"State1b1"), ENTRY(@"State2")];

    [self validateValidationSequence:sequence forRecordings:recordings];
}

@end
