// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.


#import "Scenario10StateChart.h"

IMPLEMENT_BASE_STATE(Scenario10StateChart)

STATE(Scenario10StateChart, Idle)STATE_END
STATE(Scenario10StateChart, Load)STATE_END
STATE(Scenario10StateChart, Slow)STATE_END
IMPLEMENT_STATE(Scenario10StateChart, Show)STATE_END
IMPLEMENT_AND_STATE(Scenario10StateChart, ShowAndTell)STATE_END
IMPLEMENT_STATE(Scenario10StateChart, ShowAndTellA)STATE_END
IMPLEMENT_STATE(Scenario10StateChart, ShowAndTellB)STATE_END

@implementation Scenario10StateChart

- (id)init {
    if (!(self = [super init])) {return nil;}

    _eventInPort = [self inputPortWithProtocol:@protocol(Scenario10StateChartEventProtocol) name:@"Event In"];

    return self;
}

- (void)configureWithConfiguration:(id <SHPStateChartConfigurationProtocol>)configuration {
    Idle *idle = [Idle new];
    Load *load = [Load new];
    Slow *slow = [Slow new];
    Show *show = [Show new];
    ShowAndTell *showAndTell = [ShowAndTell new];
    ShowAndTellA *showAndTellA = [ShowAndTellA new];
    ShowAndTellB *showAndTellB = [ShowAndTellB new];

    [showAndTell setRegions:@[showAndTellA, showAndTellB]];

    [configuration.rootState setSubStates:@[idle, load, slow, show, showAndTell] initialState:idle];

    [idle onEvent:@selector(event1) transitionTo:load];
    [load onEvent:@selector(event2) transitionTo:show];
    [show onEvent:@selector(event3) transitionTo:load];
    [show onEvent:@selector(event4) transitionTo:showAndTell];
}

@end
