// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.


#import "SHPStateChart.h"
#import "Scenario1StateChart.h"

BASE_STATE(Scenario1StateChart)

AND_STATE(Scenario1StateChart, State1)

- (void)event3 {
    NSLog(@"s1: ev3 state chart");
}

STATE_END
STATE(Scenario1StateChart, State1a1)STATE_END
STATE(Scenario1StateChart, State1a2)STATE_END
STATE(Scenario1StateChart, State1b1)

- (void)event2 {
    NSLog(@"s1b1: ev2 state chart");
}

STATE_END
STATE(Scenario1StateChart, State1b2)STATE_END
STATE(Scenario1StateChart, State2)

- (void)event1 {
    NSLog(@"s2: ev1 state chart");
}

STATE_END

STATE(Scenario1StateChart, State1a)

STATE_END

STATE(Scenario1StateChart, State1b)

STATE_END

@implementation Scenario1StateChart

- (id)init {
    if (!(self = [super init])) {return nil;}

    _eventInPort = [self inputPortWithProtocol:@protocol(Scenario1StateChartEventProtocol) name:@"Event In"];

    return self;
}

- (void)configureWithConfiguration:(id <SHPStateChartConfigurationProtocol>)configuration {
    State1 *s1                  = [State1 new];

    State1a *s1a               = [State1a new];
    State1a1 *s1a1              = [State1a1 new];

    State1b *s1b               = [State1b new];
    State1b1 *s1b1              = [State1b1 new];

    State2 *s2                  = [State2 new];

    [s1a setSubStates:@[s1a1] initialState:s1a1];
    [s1b setSubStates:@[s1b1] initialState:s1b1];
    [s1 setRegions:@[s1a, s1b]];
    [configuration.rootState setSubStates:@[s1, s2] initialState:s2];

    [s2 onEvent:@selector(event1) transitionTo:s1b1];
    [s1 onEvent:@selector(event3) transitionTo:s2];
    [s1b1 onEvent:@selector(event2) transitionTo:s2];
}

@end
