// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.


#import "Scenario6StateChart.h"

BASE_STATE(Scenario6StateChart)

AND_STATE(Scenario6StateChart, State1)

- (void)event3 {
    NSLog(@"s1: ev3");
}

STATE_END

STATE(Scenario6StateChart, State1a1)

- (void)event1 {
    NSLog(@"s1a1: ev1 state chart");
}

STATE_END
STATE(Scenario6StateChart, State1a2)

- (void)event2 {
    NSLog(@"s1a2: ev2 state chart");
}

STATE_END
STATE(Scenario6StateChart, State1b1)

- (void)event1 {
    NSLog(@"s1b1: ev1 state chart");
}

STATE_END
STATE(Scenario6StateChart, State1b2)

- (void)event2 {
    NSLog(@"s1b2: ev2 state chart");
}

STATE_END

STATE(Scenario6StateChart, State2)

- (void)event1 {
    NSLog(@"s2: ev1");
}
STATE_END

STATE(Scenario6StateChart, State2a)STATE_END

STATE(Scenario6StateChart, State2a1)STATE_END

STATE(Scenario6StateChart, State1a)STATE_END

STATE(Scenario6StateChart, State1b)STATE_END

@implementation Scenario6StateChart

- (id)init {
    if (!(self = [super init])) {return nil;}

    _eventInPort = [self inputPortWithProtocol:@protocol(Scenario6StateChartEventProtocol) name:@"Event In"];

    return self;
}

- (void)configureWithConfiguration:(id <SHPStateChartConfigurationProtocol>)configuration {
    State1 *s1                  = [State1 new];

    State1a *s1a                = [State1a new];
    State1a1 *s1a1              = [State1a1 new];
    State1a2 *s1a2              = [State1a2 new];

    State1b *s1b                = [State1b new];
    State1b1 *s1b1              = [State1b1 new];
    State1b2 *s1b2              = [State1b2 new];

    State2 *s2                  = [State2 new];
    State2a *s2a                = [State2a new];
    State2a1 *s2a1                = [State2a1 new];

    [s1a setSubStates:@[s1a1, s1a2] initialState:s1a1];
    [s1b setSubStates:@[s1b1, s1b2] initialState:s1b1];
    [s1 setRegions:@[s1a, s1b]];

    [s2 setSubStates:@[s2a] initialState:s2a];
    [s2a setSubStates:@[s2a1] initialState:s2a1];

    [configuration.rootState setSubStates:@[s1, s2] initialState:s1];

    [s1a1 onEvent:@selector(event1) transitionTo:s1a2];
    [s1a2 onEvent:@selector(event2) transitionTo:s1a1];
    [s1 onEvent:@selector(event3) transitionTo:s2];

    [s2a1 onEvent:@selector(event2) transitionTo:s2a1];
    [s2 onEvent:@selector(event1) transitionTo:s2a1];

    [s1b1 internalTransitionOnEvent:@selector(event1)];
}

@end
