// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.


#import "Scenario8StateChart.h"
#import "SHPStateChartGuard.h"

BASE_STATE(Scenario8StateChart)

STATE(Scenario8StateChart, State1)STATE_END
STATE(Scenario8StateChart, State2)STATE_END

STATE(Scenario8StateChart, State2a)STATE_END
STATE(Scenario8StateChart, State2a1)STATE_END
STATE(Scenario8StateChart, State2a2)STATE_END

STATE(Scenario8StateChart, State2b)STATE_END
STATE(Scenario8StateChart, State2b1)STATE_END
STATE(Scenario8StateChart, State2b2)STATE_END

@implementation Scenario8StateChart

- (id)init {
    if (!(self = [super init])) {return nil;}

    _eventInPort = [self inputPortWithProtocol:@protocol(Scenario8StateChartEventProtocol) name:@"Event In"];

    return self;
}

- (void)configureWithConfiguration:(id <SHPStateChartConfigurationProtocol>)configuration {
    State1 *s1 = [State1 new];
    State2 *s2 = [State2 new];

    State2a *s2a = [State2a new];
    State2a1 *s2a1 = [State2a1 new];
    State2a2 *s2a2 = [State2a2 new];

    State2b *s2b = [State2b new];
    State2b1 *s2b1 = [State2b1 new];
    State2b2 *s2b2 = [State2b2 new];

    [s2a setSubStates:@[s2a1, s2a2] initialState:s2a1];
    [s2b setSubStates:@[s2b1, s2b2] initialState:s2b1];
    [s2 setSubStates:@[s2a, s2b] initialState:s2a];
    [configuration.rootState setSubStates:@[s1, s2] initialState:s1];

//    [s1 onEvent:@selector(event1) transitionTo:s2];
    [s1 onEvent:@selector(event1) transitionToShallowHistoryOf:s2];
//    [s1 onEvent:@selector(event1) transitionToDeepHistoryOf:s2];
    [s2 onEvent:@selector(event1) transitionTo:s1];

    [s2a onEvent:@selector(event2) transitionTo:s2b];
    [s2a1 onEvent:@selector(event3) transitionTo:s2a2];
    [s2a2 onEvent:@selector(event3) transitionTo:s2a1];

    [s2b onEvent:@selector(event2) transitionTo:s2a];
    [s2b1 onEvent:@selector(event3) transitionTo:s2b2];
    [s2b2 onEvent:@selector(event3) transitionTo:s2b1];

}

@end
