// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "SHPStateChart.h"

@class Submachine1StateChartStateSM1;
@class Submachine1StateChartStateSM1b;

@protocol Submachine1StateChartEventProtocol
@optional
-(void)event1;
-(void)event2;
-(void)event3;
-(void)event4;
@end

@interface Submachine1StateChart : SHPStateChart

@property (strong, readonly) SHPInputPort<Submachine1StateChartEventProtocol> *eventInPort;
@property (strong, readonly) Submachine1StateChartStateSM1 *sm1;
@property (strong, readonly) Submachine1StateChartStateSM1b *sm1b;
@property (readonly) int magicConstant;
@property(nonatomic, readonly) SHPState *event3ExitState;

- (id)initWithMagicConstant:(int)constant event3ExitState:(SHPState *)event2ExitState;
@end
