// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.


#import "Submachine1StateChart.h"

BASE_STATE(Submachine1StateChart)

STATE(Submachine1StateChart, StateSM1)STATE_END
STATE(Submachine1StateChart, StateSM1a)

- (void)event1 {
    NSLog(@"sm1a: self.stateChart.magicConstant = %i", self.stateChart.magicConstant);
//    NSLog(@"sm1a:action");
}

STATE_END
STATE(Submachine1StateChart, StateSM1b)

- (void)event1 {
    NSLog(@"sm1b: self.stateChart.magicConstant = %i", self.stateChart.magicConstant);
//    NSLog(@"sm1b:action");
}

STATE_END

@implementation Submachine1StateChart

- (id)init {
    if (!(self = [self initWithMagicConstant:0 event3ExitState:nil])) {return nil;}

    return self;
}

- (id)initWithMagicConstant:(int)constant event3ExitState:(SHPState *)event2ExitState {
    _event3ExitState = event2ExitState;

    if (!(self = [super init])) {
        return nil;
    }

    _eventInPort = [self inputPortWithProtocol:@protocol(Submachine1StateChartEventProtocol) name:@"Event In"];
    _magicConstant = constant;

    return self;
}

- (void)configureWithConfiguration:(id <SHPStateChartConfigurationProtocol>)configuration {
    StateSM1 *sm1 = [StateSM1 new];
    StateSM1a *sm1a = [StateSM1a new];
    StateSM1b *sm1b = [StateSM1b new];

    [sm1 setSubStates:@[sm1a, sm1b] initialState:sm1a];
    [configuration.rootState setSubStates:@[sm1] initialState:sm1];

    [sm1a onEvent:@selector(event1) transitionTo:sm1b];
    [sm1b onEvent:@selector(event1) transitionTo:sm1a];
    [sm1b onEvent:@selector(event3) transitionTo:_event3ExitState];

    // External
    _sm1 = sm1;
    _sm1b = sm1b;
}

@end
