// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "Thread.h"


@implementation Thread {
}

- (id)init {
    self = [super init];
    if (self) {
    }

    return self;
}

- (void)main
{
    NSRunLoop *runLoop = [NSRunLoop currentRunLoop];
    [runLoop addPort:[NSMachPort port] forMode:NSDefaultRunLoopMode];

    BOOL shouldKeepRunning = YES;

    while (shouldKeepRunning && !self.isCancelled) {
        shouldKeepRunning = [runLoop runMode:NSDefaultRunLoopMode beforeDate:[NSDate distantFuture]];
    }
}

- (void)start {
    [super start];
    [self execute];
}


- (void)execute {
    [self performSelector:@selector(process)
                 onThread:self
               withObject:nil
            waitUntilDone:NO];
}

- (void)process {
    Byte *byteArray = malloc(1048576/2);
    memset(byteArray, 0, 1048576/2);

    while(YES) {
        [NSThread sleepForTimeInterval:.01];

    }
}

@end