// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>

@class SHPState;
@class SHPStateRepresentation;

typedef enum {
    SHPEventRepresentationEventTypeInitial,
    SHPEventRepresentationEventTypeExit,
    SHPEventRepresentationEventTypeEntry,
    SHPEventRepresentationEventTypeAction,
} SHPEventRepresentationEventType;

@interface SHPEventRepresentation : NSObject

@property (nonatomic, readonly) SHPEventRepresentationEventType eventType;
@property (nonatomic, readonly) NSString *eventTransitionAction;
@property (nonatomic, readonly) SHPStateRepresentation *stateRepresentation;

- (instancetype)initWithEventType:(SHPEventRepresentationEventType)eventType transitionAction:(NSString *)transitionAction stateRepresentation:(SHPStateRepresentation *)stateRepresentation;
- (NSString *)eventTypeString;

@end
