// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPComponent.h"
#import "SHPOutputPort.h"

@class SHPInputPort;
@class SHPWrappedMessage;


@protocol SHPMessageWrapperInputProtocol
@end

@protocol SHPMessageWrapperOutputProtocol
- (void)channelWrapperWrappedMessage:(SHPWrappedMessage *)message;
@end

@interface SHPMessageWrapperComponent : SHPComponent

@property (nonatomic, readonly) SHPInputPort<SHPMessageWrapperInputProtocol> *inputPort;
@property (nonatomic, readonly) SHPOutputPort<SHPMessageWrapperOutputProtocol> *outputPort;
@property (nonatomic, readonly) NSString *channelName;

- (id)initWithChannelName:(NSString *)channelName;

@end