// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPStateChart.h"

@class SHPEventMessage;
@class SHPInputPort;
@class SHPOutputPort;

@protocol SHPBonjourServerCommandProtocol
@optional
- (void)eventBonjourServerPublish;
- (void)eventBonjourServerStop;
@end

@protocol SHPBonjourServerNotificationProtocol
@optional
- (void)eventBonjourServerFailedWithError:(NSError *)error;
- (void)eventBonjourServerStopped;
- (void)eventBonjourServerStopping;
- (void)eventBonjourServerPublishing;
- (void)eventBonjourServerPublished;
@end

@interface SHPBonjourServerStateChart : SHPStateChart

@property(nonatomic, readonly) NSNetService *service;
@property (nonatomic, readonly) SHPInputPort<SHPBonjourServerCommandProtocol> *commandInputPort;
@property (nonatomic, readonly) SHPOutputPort<SHPBonjourServerNotificationProtocol> *notificationOutputPort;

- (id)initWithDomain:(NSString *)domain type:(NSString *)type name:(NSString *)name port:(uint16_t)port;

@end