// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPStateChart.h"

@protocol TikTokStateChartEventProtocol
@optional
- (void)start;
- (void)performTik;
- (void)performTok;
- (void)completedToks;

@end

@interface TikTokStateChart : SHPStateChart

@property (nonatomic, readonly) SHPEventPort<TikTokStateChartEventProtocol> *eventPort;
@property (nonatomic) int numberOfToks;
@property (nonatomic) CFTimeInterval startTime;
@property (nonatomic) CFTimeInterval timeInterval;
@property (nonatomic) NSUInteger goal;

- (id)initWithGoal:(NSUInteger)goal;
@end
