// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPComponent.h"
#import "SHPMessageClientBridgeStateChart.h"

@class SHPProxyInputPort;
@class SHPProxyOutputPort;

@protocol SHPMessageClientBridgeCommandProtocol <SHPMessageClientBridgeInputCommandProtocol>
@end

@protocol SHPMessageClientBridgeNotificationProtocol <SHPMessageClientBridgeOutputNotificationProtocol>
@end

@interface SHPMessageClientBridgeComponent : SHPComponent

@property (nonatomic, readonly) SHPProxyInputPort<SHPMessageClientBridgeCommandProtocol> *commandInputPort;
@property (nonatomic, readonly) SHPProxyOutputPort<SHPMessageClientBridgeNotificationProtocol> *notificationOutputPort;

@property (nonatomic, readonly) SHPProxyInputPort<SHPMessageClientBridgeMessageInputProtocol> *messagesInputPort;
@property (nonatomic, readonly) SHPProxyOutputPort<SHPMessageClientBridgeMessageOutputProtocol> *messagesOutputPort;

- (void)configure;

@end