// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>
#import "SHPStateChart.h"

@class SHPInputPort;
@class SHPOutputPort;
@class SHPWrappedMessage;
@protocol SHPSocketServerCommandProtocol;
@protocol SHPSocketServerNotificationProtocol;
@protocol SHPBonjourBrowserNotificationProtocol;
@protocol SHPBonjourServerCommandProtocol;


@protocol SHPMessageServerBridgeNotificationInputProtocol <SHPSocketServerNotificationProtocol, SHPBonjourBrowserNotificationProtocol>
@end

@protocol SHPMessageServerBridgeNotificationOutputProtocol
@end

@protocol SHPMessageServerBridgeCommandOutputProtocol <SHPSocketServerCommandProtocol, SHPBonjourServerCommandProtocol>

@end

@protocol SHPMessageServerBridgeCommandInputProtocol
@optional
- (void)eventMessageServerBridgeStart;
- (void)eventMessageServerBridgeStop;
@end

@protocol SHPMessageServerBridgeMessageOutputProtocol
@optional
- (void)eventMessageServerBridgeReceivedMessage:(SHPWrappedMessage *)message;
@end

@protocol SHPMessageServerBridgeMessageInputProtocol
@optional
- (void)eventMessageServerBridgeSendMessage:(SHPWrappedMessage *)message;
@end

@interface SHPMessageServerBridgeStateChart : SHPStateChart

@property (nonatomic, readonly) SHPInputPort<SHPMessageServerBridgeCommandInputProtocol> *commandInputPort;
@property (nonatomic, readonly) SHPOutputPort<SHPMessageServerBridgeNotificationOutputProtocol> *notificationOutputPort;

@property (nonatomic, readonly) SHPOutputPort<SHPMessageServerBridgeCommandOutputProtocol> *commandOutputPort;
@property (nonatomic, readonly) SHPInputPort<SHPMessageServerBridgeNotificationInputProtocol> *notificationInputPort;

@property (nonatomic, readonly) SHPInputPort<SHPMessageServerBridgeMessageInputProtocol> *messageInputPort;
@property (nonatomic, readonly) SHPOutputPort<SHPMessageServerBridgeMessageOutputProtocol> *messageOutputPort;

@end