// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <Foundation/Foundation.h>

enum SHPStandardErrorCodes {
	SHPUnknowErrorCode = 1000
};

/// Easy creation of errors without specifying a domain and optionally also ommiting a code. The bundle identifier is used as domain (bundle identifier).
@interface NSError (ConvenienceCreatorAdditions)

/// ---------------------------------------------------------------------
/// @name Simple Creation of Error Objects
/// ---------------------------------------------------------------------

/// Creates and initializes an NSError object for a given description but with default domain and error code
+(NSError *)errorWithDescription:(NSString *)localizedDescription;

/// Creates and initializes an NSError object for a given description and error code but with default domain (bundle identifier).
+(NSError *)errorWithDescription:(NSString *)localizedDescription code:(NSInteger)code;

@end