// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "NSError+ConvenienceCreatorAdditions.h"


@implementation NSError (ConvenienceCreatorAdditions)

+ (NSError *)errorWithDescription:(NSString *)localizedDescription {
	return [NSError errorWithDescription:localizedDescription code:SHPUnknowErrorCode];
}

+ (NSError *)errorWithDescription:(NSString *)localizedDescription code:(NSInteger)code {
	NSString *domain = [[NSBundle mainBundle] objectForInfoDictionaryKey:@"CFBundleIdentifier"];
	NSError *error = [NSError errorWithDomain:domain code:code userInfo:[NSDictionary dictionaryWithObject:localizedDescription forKey:NSLocalizedDescriptionKey]];
	return error;
}

@end