// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "NSObject+SHPDelegation.h"

@implementation NSObject(SHPDelegation)

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Warc-performSelector-leaks"

- (void)performDelegateSelector:(SEL)selector withObject:(id)object {
    id receiver = self;
    if ([receiver delegate] && [[receiver delegate] respondsToSelector:selector]) {
        [[receiver delegate] performSelector:selector withObject:object];
    }
}

- (void)performDelegateSelector:(SEL)selector withObject:(id)object1 withObject:(id)object2 {
    id receiver = self;
    if ([receiver delegate] && [[receiver delegate] respondsToSelector:selector]) {
        [[receiver delegate] performSelector:selector withObject:object1 withObject:object2];
    }
}

#pragma clang diagnostic pop

@end
