// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <SHPStateChart/SHPMessageRouter.h>
#import "SHPUtilities.h"


@implementation SHPChannel {
    SHPMessageRouter *_messageRouter;
}

- (id)init {
    return [self initWithType:SHPChannelTypePublishSubscribe messageRouter:[SHPMessageRouter sharedInstance]];
}

/**
*   Designated initializer
*/
- (id)initWithType:(SHPChannelType)type messageRouter:(SHPMessageRouter *)messageRouter {
    if (!(self = [super init])) {
        return nil;
    }

    _messageRouter = messageRouter;
    _identifier = SHPCreateUDID();
    _type = type;
    _receivers = [NSMutableArray array];


    return self;
}

- (void)postMessage:(SHPEventMessage *)message {
    [_messageRouter sendMessage:message channel:self];
}

- (void)receiverReady:(id<SHPChannelDelegate>)receiver {
    [_messageRouter receiverReady:receiver forChannel:self];
}

@end