// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "SHPEventMessage.h"
#import "SHPUtilities.h"
#import "SHPComponent.h"

@implementation SHPEventMessage {
}

- (id)initWithEventType:(SEL)eventType invocation:(NSInvocation *)invocation {
    return [self initWithEventType:eventType invocation:invocation senderName:nil parentMessage:nil];
}

- (id)initWithEventType:(SEL)eventType invocation:(NSInvocation *)invocation senderName:(NSString *)senderName parentMessage:(SHPEventMessage *)parentMessage {
    self = [super init];
    if (self) {
        _invocation = invocation;
        _eventType = eventType;
        _identifier = SHPCreateUDID();
        _timestamp = [[NSDate date] timeIntervalSince1970];
        _parentMessage = parentMessage;
        _senderName = senderName;

        _traceIdentifier = parentMessage.traceIdentifier ?: SHPCreateUDID();
    }

    return self;
}

- (NSString *)description {
    NSMutableString *description = [NSMutableString stringWithFormat:@"<%@: ", NSStringFromClass([self class])];
    [description appendFormat:@"%@", NSStringFromSelector(self.invocation.selector)];
    [description appendString:@">"];
    return description;
}


@end