// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "SHPLoggingUtilities.h"
#import "SHPComponent.h"


NSDateFormatter *LogDateFormatter() {
    NSMutableDictionary *threadCache = [[NSThread currentThread] threadDictionary];
    NSDateFormatter *df = threadCache[@"SHPLOG_DATE_FORMATTER"];
    if (!df) {
        df = [[NSDateFormatter alloc] init];
        df.dateFormat = @"HH:mm:ss.SSS";
        threadCache[@"SHPLOG_DATE_FORMATTER"] = df;
    }
    return df;
}

NSString* SHPComponentLogFunction(NSString *format,SHPComponent *component, NSString *file, NSUInteger line, ...) {
    NSDateFormatter *df = ThreadLocalLogDateFormatter();
    NSString *timeStr = [df stringFromDate:[NSDate date]];

    va_list args;
    va_start(args, format);
    NSString *logStr = [[NSString alloc] initWithFormat:format arguments:args];
    NSString *withTimeStr = [[NSString alloc] initWithFormat:@"%@ : %@ (%@:%d - %@)", timeStr, logStr, file, line, component.name];
    va_end(args);
    return withTimeStr;
}
