// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <SHPStateChart/SHPStateChart.h>
#import "SHPEventPort.h"
#import "SHPComponent.h"
#import "SHPEventMessage.h"


@implementation SHPEventPort {

}

- (id)initWithComponent:(SHPComponent *)component protocol:(Protocol *)protocol {
    self = [super initWithProtocol:protocol];

    if (self) {
        self.component = component;
    }

    return self;
}

- (void)forwardInvocation:(NSInvocation *)invocation {
    [invocation retainArguments];
    SHPEventMessage *parentMessage = nil;
    parentMessage = self.owner.portTraceDictionary.allValues.firstObject;
    SHPEventMessage *eventMessage = [[SHPEventMessage alloc] initWithEventType:invocation.selector invocation:invocation senderName:self.component.name parentMessage:parentMessage];

    dispatch_async(self.component.messageQueue, ^{
        [self.component inputPort:self didReceiveMessage:eventMessage];
    });
}

@end