// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <SHPStateChart/SHPComponent.h>
#import <SHPStateChart/SHPEventMessage.h>
#import "SHPInputPort.h"
#import "SHPEventMessage.h"


@implementation SHPInputPort {

}

- (id)initWithOwner:(id <SHPInputPortProtocol>)owner protocol:(Protocol *)protocol name:(NSString *)name {
    self = [super initWithOwner:owner protocol:protocol name:name];
    if (self) {
        _portType = SHPPortTypeInput;
    }

    return self;
}

- (void)setChannel:(SHPChannel *)channel {
    [channel receiverReady:self];
    _channel = channel;
}

- (void)channel:(SHPChannel *)channel processMessage:(SHPEventMessage *)message {

}

- (void)channel:(SHPChannel *)channel didDeliverMessage:(SHPEventMessage *)message {
    dispatch_async(self.owner.messageQueue, ^{
        NSString *key = NSStringFromSelector(message.invocation.selector);
        [self.owner.portTraceDictionary setObject:message forKey:key];
        [self.owner inputPort:self didReceiveMessage:message];
        [self.owner.portTraceDictionary removeObjectForKey:key];
    });
}

- (dispatch_queue_t)messageQueue {
    return nil;
}

- (void)forwardInvocation:(NSInvocation *)invocation {
    [invocation setTarget:self.owner];
    [invocation invoke];
}

@end