// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <objc/runtime.h>
#import "SHPInvocationProxy.h"

@implementation SHPInvocationProxy {

}

- (id)initWithProtocol:(Protocol *) protocol {
    self.protocol = protocol;

    return self;
}

- (NSMethodSignature *)methodSignatureForSelector:(SEL)inSelector {
    NSAssert(self.protocol!= nil, @"Protocol must be specified");
    struct objc_method_description methodDescription = protocol_getMethodDescription(self.protocol,inSelector, YES, YES);
    if (!methodDescription.name) {
        methodDescription = protocol_getMethodDescription(self.protocol,inSelector, NO, YES);
    }

    if (!methodDescription.name) {
        return nil;
    }

    NSMethodSignature *methodSignature = [NSMethodSignature signatureWithObjCTypes:methodDescription.types];

    return methodSignature;
}

@end
