// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <SHPStateChart/SHPComponent.h>
#import "SHPOutputPort.h"
#import "SHPEventMessage.h"

@implementation SHPOutputPort {

}

- (id)initWithOwner:(id<SHPOutputPortProtocol>)owner protocol:(Protocol *)protocol name:(NSString *)name {
    return [self initWithOwner:owner protocol:protocol name:name tracing:YES];
}


- (id)initWithOwner:(id<SHPOutputPortProtocol>)owner protocol:(Protocol *)protocol name:(NSString *)name tracing:(BOOL)tracing {
    self = [super initWithOwner:owner protocol:protocol name:name];
    if (self) {
        _portType = SHPPortTypeOutput;
        _tracing = tracing;
    }

    return self;
}

- (void)forwardInvocation:(NSInvocation *)invocation {
    SHPEventMessage *parentMessage = nil;

//    if(_tracing) {
//        parentMessage = self.owner.portTraceDictionary.allValues.firstObject;
//    }

    [invocation retainArguments];
    SHPEventMessage *eventMessage = [[SHPEventMessage alloc] initWithEventType:invocation.selector invocation:invocation senderName:self.owner.name parentMessage:parentMessage];
    [self.channel postMessage:eventMessage];
}

@end