// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "SHPProxyInputPort.h"
#import "SHPEventMessage.h"


@interface SHPProxyInputPort () <SHPChannelDelegate>
@end

@implementation SHPProxyInputPort {

}

- (id)initWithOwner:(id <SHPChannelDelegate>)owner protocol:(Protocol *)protocol name:(NSString *)name {
    self = [super initWithOwner:owner protocol:protocol name:name];
    if (self) {
        _portType = SHPPortTypeProxyInput;
    }

    return self;
}

- (void)setChannel:(SHPChannel *)channel {
    [channel receiverReady:self];
    _channel = channel;
}

- (void)channel:(SHPChannel *)channel didDeliverMessage:(SHPEventMessage *)message {
    NSAssert(self.proxyChannel!=nil, @"Proxy channel must not be nil");

    [self.proxyChannel postMessage:message];
}

- (void)channel:(SHPChannel *)channel processMessage:(SHPEventMessage *)message {

}

- (dispatch_queue_t)messageQueue {
    return nil;
}

- (void)forwardInvocation:(NSInvocation *)invocation {
    NSAssert(self.proxyChannel!=nil, @"Proxy channel must not be nil");

    [invocation retainArguments];
    SHPEventMessage *eventMessage = [[SHPEventMessage alloc] initWithEventType:invocation.selector invocation:invocation];
    [self.proxyChannel postMessage:eventMessage];
}


@end