// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "SHPProxyOutputPort.h"
#import "SHPPort.h"
#import "SHPEventMessage.h"


@interface SHPProxyOutputPort () <SHPChannelDelegate>
@end

@implementation SHPProxyOutputPort {

}

- (id)initWithOwner:(id <SHPChannelDelegate>)owner protocol:(Protocol *)protocol name:(NSString *)name {
    self = [super initWithOwner:owner protocol:protocol name:name];
    if (self) {
        _portType = SHPPortTypeProxyOutput;
    }

    return self;
}

- (void)setProxyChannel:(SHPChannel *)proxyChannel {
    _proxyChannel = proxyChannel;
    [_proxyChannel receiverReady:self];
}

- (void)channel:(SHPChannel *)channel processMessage:(SHPEventMessage *)message {

}

- (void)channel:(SHPChannel *)channel didDeliverMessage:(SHPEventMessage *)message {
    [self.channel postMessage:message];
}

- (dispatch_queue_t)messageQueue {
    return nil;
}

- (void)forwardInvocation:(NSInvocation *)invocation {
    SHPEventMessage *parentMessage = nil;

    [invocation retainArguments];
    SHPEventMessage *eventMessage = [[SHPEventMessage alloc] initWithEventType:invocation.selector invocation:invocation senderName:@"Sender" parentMessage:parentMessage];
    [self.channel postMessage:eventMessage];
}


@end