// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.


#import "SHPAndStateRepresentation.h"
#import "NSArrayCollections.h"

@interface SHPAndStateRepresentation ()

@end

@implementation SHPAndStateRepresentation

- (NSString *)treeDescriptionWithIndentationLevel:(NSUInteger)level {
    NSMutableString *indentationString = [NSMutableString new];
    for (int i = 0; i < level; i++) {
        [indentationString appendString:@"+"];
    }

    NSUInteger nextLevel = level+1;
    NSArray *regionNames = [_regions collect:^id(SHPStateRepresentation *region) { return [NSString stringWithFormat:@"%@%@", indentationString, [region treeDescriptionWithIndentationLevel:nextLevel]]; }];


    NSString *description = [NSString stringWithFormat:@"%@\n%@", [self shortNameWithActiveIndicator], [regionNames componentsJoinedByString:[NSString stringWithFormat:@"\n"]]];

    return description;
}

- (NSString *)shortNameWithActiveIndicator {
    return self.active ? [NSString stringWithFormat:@"%@*", self.shortName] : self.shortName;
}

- (NSString *)description {
    return [NSString stringWithFormat:@"SHPAndStateRepresentation: %@", [self shortNameWithActiveIndicator]];
}

@end
