// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "SHPEventRepresentation.h"
#import "SHPEventHandlingResult.h"
#import "SHPTransitionRepresentation.h"


@implementation SHPEventHandlingResult {
}

- (id)initWithEvent:(NSString *)event {
    if (!(self = [super init])) {return nil;}

    _event = event;
    _transitionRepresentations = [NSMutableArray new];

    return self;
}

- (void)addTransitionRepresentation:(SHPTransitionRepresentation *)transitionRepresentation {
    _transitionRepresentations = [_transitionRepresentations arrayByAddingObject:transitionRepresentation];
}

- (NSArray *)transitionRepresentations {
    return [_transitionRepresentations copy];
}

- (NSString *)description {
    NSString *description = [NSString stringWithFormat:@"Handling event %@", _event];

    return description;
}

@end
