// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.


#import "SHPOrStateRepresentation.h"
#import "NSArrayCollections.h"
#import "SHPStateRepresentation.h"

@interface SHPOrStateRepresentation ()

@end

@implementation SHPOrStateRepresentation

- (NSString *)treeDescriptionWithIndentationLevel:(NSUInteger)level {
    NSMutableString *indentationString = [NSMutableString new];
    for (int i = 0; i < level; i++) {
        [indentationString appendString:@" "];
    }

    NSUInteger nextLevel = level+1;
    NSArray *subStateNames = [_subStates collect:^id(SHPStateRepresentation *subState) { return [NSString stringWithFormat:@"%@%@", indentationString, [subState treeDescriptionWithIndentationLevel:nextLevel]]; }];

    NSString *description;
    if (subStateNames) {
        description = [NSString stringWithFormat:@"%@\n%@", [self shortNameWithActiveIndicator], [subStateNames componentsJoinedByString:@"\n"]];
    } else {
        description = [NSString stringWithFormat:@"%@", [self shortNameWithActiveIndicator]];
    }
    return description;
}

- (NSString *)shortNameWithActiveIndicator {
    return self.active ? [NSString stringWithFormat:@"%@*", self.shortName] : self.shortName;
}

- (NSString *)description {
    return [NSString stringWithFormat:@"SHPOrStateRepresentation: %@", [self shortNameWithActiveIndicator]];
}

@end
