// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.


#import "SHPTransitionRepresentation.h"
#import "SHPStateChartGuardRepresentation.h"
#import "SHPEventRepresentation.h"

@interface SHPTransitionRepresentation ()

@end

@implementation SHPTransitionRepresentation {
}

- (id)initWithEvent:(NSString *)event fromStates:(NSArray *)fromStates toStates:(NSArray *)toStates timeout:(NSNumber *)timeout internal:(BOOL)internal guard:(SHPStateChartGuardRepresentation *)guard historyMode:(NSString *)mode {
    if (!(self = [super init])) {return nil;}

    _event = event;
    _fromStates = fromStates;
    _toStates = toStates;
    _timeout = timeout;
    _internal = internal;
    _guard = guard;
    _historyMode = mode;

    _eventRepresentations = [NSMutableArray array];

    return self;
}

- (void)addEventRepresentation:(SHPEventRepresentation *)eventRepresentation {
    _eventRepresentations = [_eventRepresentations arrayByAddingObject:eventRepresentation];
}

- (NSString *)description {
    NSMutableString *description = [[NSString stringWithFormat:@"Transition on event %@ from [%@] -> [%@], timeout: %@, isInternal: %@, guard: %@, historyMode: %@", _event, [_fromStates componentsJoinedByString:@", "], [_toStates componentsJoinedByString:@", "], _timeout, (_internal ? @"YES" : @"NO"), _guard, _historyMode] mutableCopy];

    return [description copy];
}

- (NSArray *)eventRepresentations {
    return [_eventRepresentations copy];
}

@end
