// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "SHPStateChartGuard.h"
#import "SHPStateChartGuardRepresentation.h"


@implementation SHPStateChartGuard {

}

- (id)initWithCondition:(BOOL (^)())condition guardDescription:(NSString *)guardDescription {
    self = [super init];
    if (self) {
        _condition = condition;
        _guardDescription = guardDescription;
    }

    return self;
}

+ (SHPStateChartGuard *)guardWithCondition:(BOOL (^)())condition guardDescription:(NSString *)guardDescription {
    return [[SHPStateChartGuard alloc] initWithCondition:condition guardDescription:guardDescription];
}

- (SHPStateChartGuardRepresentation *)representationForGuard {
    SHPStateChartGuardRepresentation *stateChartGuardRepresentation = [[SHPStateChartGuardRepresentation alloc] initWithGuardDescription:_guardDescription];

    return stateChartGuardRepresentation;
}

@end
