// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import <SHPStateChart/SHPState.h>
#import "SHPStateChartGuardTransition.h"
#import "SHPStateChartGuard.h"

@interface SHPStateChartGuardTransition ()

@end

@implementation SHPStateChartGuardTransition

- (instancetype)initWithEvent:(SEL)event action:(SEL)action fromStates:(NSArray *)fromStates toStates:(NSArray *)toStates timeout:(NSNumber *)timeout internal:(BOOL)internal guard:(SHPStateChartGuard *)guard {
    self = [super initWithEvent:event fromStates:fromStates toStates:toStates timeout:timeout internal:internal guard:guard historyMode:(HistoryModeShallow)];
    if (self) {
        _action = action;
    }

    return self;
}

+ (instancetype)transitionWithEvent:(SEL)event action:(SEL)action fromStates:(NSArray *)fromStates toStates:(NSArray *)toStates timeout:(NSNumber *)timeout internal:(BOOL)internal guard:(SHPStateChartGuard *)guard {
    return [[self alloc] initWithEvent:event action:action fromStates:fromStates toStates:toStates timeout:timeout internal:internal guard:guard];
}

- (NSString *)description {
    NSMutableString *description = [NSMutableString stringWithFormat:@"<%@: ", NSStringFromClass([self class])];
    [description appendFormat:@"self.event=%p", self.event];
    [description appendFormat:@", self.action=%p", self.action];
    [description appendFormat:@", self.fromStates=%@", self.fromStates];
    [description appendFormat:@", self.toStates=%@", self.toStates];
    [description appendFormat:@", self.guard=%@", self.guard];
    [description appendFormat:@", self.timeout=%@", self.timeout];
    [description appendFormat:@", self.internal=%d", self.internal];
    [description appendString:@">"];
    return description;
}

@end
