// This software is licensed under GNU GLP version 3. Please read the file licence.txt for the complete licence text.
// 
// Copyright (c) 2014, Peter Gammelgaard, Philip Bruce & Shape A/S. All rights reserved.

#import "SHPTracingMessage.h"
#import "SHPEventMessage.h"


@implementation SHPTracingMessage {
    NSMutableArray *_childMessages;
}

- (instancetype)initWithMessage:(SHPEventMessage *)message parentTracingMessage:(SHPTracingMessage *)parentMessage {
    self = [super init];
    if (self) {
        _parentTracingMessage = parentMessage;
        _childMessages = [NSMutableArray new];
        _message = message;
    }

    return self;
}

- (void)addChildMessage:(SHPEventMessage *)message {
    [_childMessages addObject:message];
}

- (NSString *)description {
    NSMutableString *description = [NSMutableString stringWithFormat:@"<%@: ", NSStringFromClass([self class])];

    if(_message.parentMessage) {

    }

    [description appendFormat:@"%@ -> %@", _message.senderName, NSStringFromSelector(_message.eventType)];
    [description appendString:@">"];
    return description;
}


@end